

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.1.8. groonga-suggest-httpd &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.1.9. groonga-suggest-learner" href="groonga-suggest-learner.html" />
    <link rel="prev" title="7.1.7. groonga-suggest-create-dataset" href="groonga-suggest-create-dataset.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/executables/groonga-suggest-httpd.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="groonga-suggest-learner.html" title="7.1.9. groonga-suggest-learner"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="groonga-suggest-create-dataset.html" title="7.1.7. groonga-suggest-create-dataset"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../executables.html" accesskey="U"><span class="section-number">7.1. </span>実行ファイル</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.1.8. </span><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="groonga-suggest-httpd">
<h1><span class="section-number">7.1.8. </span><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code><a class="headerlink" href="#groonga-suggest-httpd" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.1.8.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> は次の機能に対するHTTPインターフェイスを提供するプログラムです。</p>
<blockquote>
<div><ul class="simple">
<li><p><a class="reference internal" href="../suggest.html"><span class="doc">サジェスト</span></a> を実行した結果を返す</p></li>
<li><p>学習用にログを保存する</p></li>
</ul>
</div></blockquote>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> は <a class="reference internal" href="../commands/suggest.html"><span class="doc">suggest</span></a> コマンドのようなサジェスト機能を提供します。いくつかパラメーター名が異なることに注意してください。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.1.8.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> にはデータベースのパスを指定します。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>groonga-suggest-httpd [options] DATABASE_PATH
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.1.8.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を使う場合は1つ以上のデータセットを作る必要があります。データセットはテーブルとカラムの集まりです。これらのテーブル・カラムは <a class="reference internal" href="groonga-suggest-create-dataset.html"><span class="doc">groonga-suggest-create-dataset</span></a> で作成できます。</p>
<p>ユーザーの入力からサジェスト用データを学習するには <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> を使う必要があります。手動でサジェスト用データを作成する場合は <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> を使う必要はありません。手動でサジェスト用データを作る方法については <a class="reference internal" href="../suggest.html"><span class="doc">サジェスト</span></a> とその関連ドキュメントを参照してください。</p>
<p>1つ以上のデータセットを作ったらHTTP経由で <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を使えます。</p>
<p>つづくセクションでは次のことについて説明します。</p>
<blockquote>
<div><ul class="simple">
<li><p>データセットのセットアップ方法</p></li>
<li><p><a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> と一緒に <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を使う方法</p></li>
<li><p>サジェスト結果を取得するために <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を使う方法</p></li>
</ul>
</div></blockquote>
<div class="section" id="setup">
<h3><span class="section-number">7.1.8.3.1. </span>セットアップ<a class="headerlink" href="#setup" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><a class="reference internal" href="groonga-suggest-create-dataset.html"><span class="doc">groonga-suggest-create-dataset</span></a> でデータセットを作ります。</p>
<p>以下は <code class="docutils literal notranslate"><span class="pre">query</span></code> データセットを作る例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% groonga-suggest-create-dataset ${DB_PATH} query
&gt; plugin_register suggest/suggest
false
&gt; table_create event_type TABLE_HASH_KEY ShortText
true
&gt; table_create bigram TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram --normalizer NormalizerAuto
true
&gt; table_create kana TABLE_PAT_KEY ShortText --normalizer NormalizerAuto
true
&gt; table_create item_query TABLE_PAT_KEY ShortText --default_tokenizer TokenDelimit --normalizer NormalizerAuto
true
&gt; column_create bigram item_query_key COLUMN_INDEX|WITH_POSITION item_query _key
true
&gt; column_create item_query kana COLUMN_VECTOR kana
true
&gt; column_create kana item_query_kana COLUMN_INDEX item_query kana
true
&gt; column_create item_query freq COLUMN_SCALAR Int32
true
&gt; column_create item_query last COLUMN_SCALAR Time
true
&gt; column_create item_query boost COLUMN_SCALAR Int32
true
&gt; column_create item_query freq2 COLUMN_SCALAR Int32
true
&gt; column_create item_query buzz COLUMN_SCALAR Int32
true
&gt; table_create pair_query TABLE_HASH_KEY UInt64
true
&gt; column_create pair_query pre COLUMN_SCALAR item_query
true
&gt; column_create pair_query post COLUMN_SCALAR item_query
true
&gt; column_create pair_query freq0 COLUMN_SCALAR Int32
true
&gt; column_create pair_query freq1 COLUMN_SCALAR Int32
true
&gt; column_create pair_query freq2 COLUMN_SCALAR Int32
true
&gt; column_create item_query co COLUMN_INDEX pair_query pre
true
&gt; table_create sequence_query TABLE_HASH_KEY ShortText
true
&gt; table_create event_query TABLE_NO_KEY
true
&gt; column_create sequence_query events COLUMN_VECTOR|RING_BUFFER event_query
true
&gt; column_create event_query type COLUMN_SCALAR event_type
true
&gt; column_create event_query time COLUMN_SCALAR Time
true
&gt; column_create event_query item COLUMN_SCALAR item_query
true
&gt; column_create event_query sequence COLUMN_SCALAR sequence_query
true
&gt; table_create configuration TABLE_HASH_KEY ShortText
true
&gt; column_create configuration weight COLUMN_SCALAR UInt32
true
&gt; load --table configuration
&gt; [
&gt; {&quot;_key&quot;: &quot;query&quot;, &quot;weight&quot;: 1}
&gt; ]
1
</pre></div>
</div>
<p><a class="reference internal" href="groonga-suggest-create-dataset.html"><span class="doc">groonga-suggest-create-dataset</span></a> は実行したコマンドを出力します。新しいデータセット用にどんなテーブル・カラムを作ったかを確認できます。</p>
</div>
<div class="section" id="launch-groonga-suggest-learner">
<h3><span class="section-number">7.1.8.3.2. </span><code class="docutils literal notranslate"><span class="pre">groonga-suggest-learner</span></code> を起動<a class="headerlink" href="#launch-groonga-suggest-learner" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>学習したサジェストデータをすぐに使うかどうかを選択できます。</p>
<p>学習したサジェストデータをすぐに使う方法は2つあります。</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> と <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> のどちらも同じデータベースを使う</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> が <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> から学習したサジェストデータを受け取る</p></li>
</ul>
</div></blockquote>
<p>前者のケースでは、 <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> と <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> を同じホスト上で実行しなければいけません。</p>
<p>後者のケースでは、 <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> と <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> を違うホストで動かせます。</p>
<p>学習したサジェストデータをすぐに使う必要がないとき、 <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> が使っているデータベースから <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> が使っているデータベースに学習したサジェストデータを主導で反映する必要があります。通常、こちらの使い方を推奨します。なぜなら学習したサジェストデータには悪意のあるユーザーが入力由来のゴミデータが含まれているかもしれないからです。</p>
<p>このドキュメントでは <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> から学習したサジェストデータを受け取り、学習したサジェストデータをすぐに使います。 <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> と <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> はどちらも同じホストで動かします。これは説明しやすいからです。</p>
<p>以下は <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> を起動する例です。 <code class="docutils literal notranslate"><span class="pre">query</span></code> データセットがあるデータベースを指定します。このドキュメントでは <code class="docutils literal notranslate"><span class="pre">query</span></code> データセットを作る手順は省略します。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% groonga-suggest-learner --daemon ${DB_PATH}
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-learner</span></code> プロセスは2つのエンドポイントを提供します。それぞれ <code class="docutils literal notranslate"><span class="pre">1234</span></code> 番ポートと <code class="docutils literal notranslate"><span class="pre">1235</span></code> 番ポートを使います。</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">1234</span></code> 番ポート： <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> からユーザーの入力を受け付けるエンドポイント</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">1235</span></code> 番ポート： <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> に学習したサジェストデータを送信するエンドポイント</p></li>
</ul>
</div></blockquote>
</div>
<div class="section" id="launch-groonga-suggest-httpd">
<h3><span class="section-number">7.1.8.3.3. </span><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を起動<a class="headerlink" href="#launch-groonga-suggest-httpd" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>次の目的のため、 <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を起動します。</p>
<blockquote>
<div><ul class="simple">
<li><p>ユーザーの入力からサジェストデータを学習するため</p></li>
<li><p>サジェスト結果をクライアントに提供するため</p></li>
</ul>
</div></blockquote>
<p>以下は <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> と通信する <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を起動する例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% groonga-suggest-httpd --send-endpoint &#39;tcp://127.0.0.1:1234&#39; --receive-endpoint &#39;tcp://127.0.0.1:1235&#39; --daemon ${DB_PATH}
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> プロセスは <code class="docutils literal notranslate"><span class="pre">8080</span></code> 番ポートでHTTPリクエストを受け付けます。</p>
<p>リクエストをログファイルに保存したい場合は <a class="reference internal" href="#cmdoption-groonga-suggest-httpd-l"><code class="xref std std-option docutils literal notranslate"><span class="pre">--log-base-path</span></code></a> オプションを指定してください。</p>
<p>以下は各ログファイルに <code class="docutils literal notranslate"><span class="pre">log</span></code> というプレフィックスをつけて <code class="docutils literal notranslate"><span class="pre">logs</span></code> ディレクトリーに保存する例です。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% groonga-suggest-httpd --log-base-path logs/log ${DB_PATH}
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> は <code class="docutils literal notranslate"><span class="pre">logYYYYmmddHHMMSS-00</span></code> という名前のログファイルを作成し、 <code class="docutils literal notranslate"><span class="pre">logs</span></code> ディレクトリー以下に保存します。</p>
</div>
<div class="section" id="learn-from-user-inputs">
<h3><span class="section-number">7.1.8.3.4. </span>ユーザーの入力から学習<a class="headerlink" href="#learn-from-user-inputs" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>ユーザーの入力からサジェストデータを学習できます。</p>
<p>サジェストデータを学習するには次のパラメーターを指定する必要があります。</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">i</span></code>: The ID of the user (You may use IP address of client)</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">l</span></code> ：データセット名</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">s</span></code> ：入力のタイムスタンプ。単位は秒。</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">t</span></code> ：クエリーの種類。（省略可能。ユーザーの入力がサブミットされたときだけ <code class="docutils literal notranslate"><span class="pre">submit</span></code> を指定します。）</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">q</span></code> ：ユーザーの入力</p></li>
</ul>
</div></blockquote>
<p>以下は <code class="docutils literal notranslate"><span class="pre">query</span></code> データセットで「Groonga」というユーザーの入力を学習するリクエスト例です。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>.. groonga-command
.. include:: ../../example/reference/executables/groonga-suggest-httpd/learn.log
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=92619&amp;q=G&#39;
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=93850&amp;q=Gr&#39;
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=94293&amp;q=Gro&#39;
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=94734&amp;q=Groo&#39;
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=95147&amp;q=Grooon&#39;
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=95553&amp;q=Groonga&#39;
.. % curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=95959&amp;t=submit&amp;q=Groonga&#39;
</pre></div>
</div>
<p>入力中のデータに <code class="docutils literal notranslate"><span class="pre">t=submit</span></code> パラメーターをつけてはいけません。上の例では、ユーザーの入力を学習しているだけですが、ユーザーの入力を学習しながら同時に補完候補を取得することもできます。これは次のセクションで説明します。</p>
<p>サブミットされたデータには <code class="docutils literal notranslate"><span class="pre">t=submit</span></code> パラメーターをつけます。</p>
</div>
<div class="section" id="use-suggested-response">
<h3><span class="section-number">7.1.8.3.5. </span>サジェスト結果を使う<a class="headerlink" href="#use-suggested-response" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> からのサジェスト結果を使えます。</p>
<p>サジェスト結果を取得するには次のパラメーターを指定します。</p>
<blockquote>
<div><ul class="simple">
<li><p><code class="docutils literal notranslate"><span class="pre">n</span></code> ：データセット名</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">t</span></code> ：クエリーの種類（ <code class="docutils literal notranslate"><span class="pre">complete</span></code> 、 <code class="docutils literal notranslate"><span class="pre">correct</span></code> 、 <code class="docutils literal notranslate"><span class="pre">suggest</span></code> のどれか。複数指定も可。）</p></li>
<li><p><code class="docutils literal notranslate"><span class="pre">q</span></code> ：ユーザーの入力</p></li>
</ul>
</div></blockquote>
<p><a class="reference internal" href="../commands/suggest.html"><span class="doc">suggest</span></a> のパラメーターを指定することもできます。</p>
<p>以下は <a class="reference internal" href="../suggest/completion.html"><span class="doc">補完</span></a> 結果を取得する例です。この結果は前のセクションで学習したデータを使って計算しています。 <code class="docutils literal notranslate"><span class="pre">frequency_threshold=1</span></code> パラメーターを使っているのはこれが例だからです。このパラメーターは1回以上出現した入力データも有効なデータとします。通常、プロダクション環境ではこのパラメーターを指定するべきではありません。ノイズが増える可能性が高いからです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% curl &#39;http://localhost:8080/?n=query&amp;t=complete&amp;q=G&amp;frequency_threshold=1&#39;
</pre></div>
</div>
<p>補完用と学習用のどちらのパラメーターも指定することで補完と学習を組み合わせることができます。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>% curl &#39;http://localhost:8080/?i=127.0.0.1&amp;l=query&amp;s=96000&amp;q=G&amp;n=query&amp;t=complete&amp;frequency_threshold=1&#39;
</pre></div>
</div>
</div>
</div>
<div class="section" id="command-line-parameters">
<h2><span class="section-number">7.1.8.4. </span>コマンドライン引数<a class="headerlink" href="#command-line-parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.1.8.4.1. </span>必須引数<a class="headerlink" href="#required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>必須の引数は1つです。</p>
<div class="section" id="database-path">
<h4><span class="section-number">7.1.8.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">DATABASE_PATH</span></code><a class="headerlink" href="#database-path" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>Groongaのデータベースのパスを指定します。このデータベースには1つ以上のデータセットを作っておいてください。各データセットは <a class="reference internal" href="groonga-suggest-create-dataset.html"><span class="doc">groonga-suggest-create-dataset</span></a> で作ります。</p>
</div>
</div>
<div class="section" id="optional-parameters">
<h3><span class="section-number">7.1.8.4.2. </span>省略可能引数<a class="headerlink" href="#optional-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-p">
<span id="cmdoption-groonga-suggest-httpd-port"></span><code class="sig-name descname">-p</code><code class="sig-prename descclassname"></code><code class="sig-prename descclassname">, </code><code class="sig-name descname">--port</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-p" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>HTTPサーバーのポート番号を指定します。</p>
<p>デフォルトのポート番号は <code class="docutils literal notranslate"><span class="pre">8080</span></code> です。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-t">
<span id="cmdoption-groonga-suggest-httpd-n-threads"></span><code class="sig-name descname">-t</code><code class="sig-prename descclassname"></code><code class="sig-prename descclassname">, </code><code class="sig-name descname">--n-threads</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-t" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>最大スレッド数を指定します。</p>
<p>最大で128を指定できますが、パフォーマンスを出すためには最大でもCPUコア数を指定する方がよいです。</p>
<p>デフォルトはコア数です。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-s">
<span id="cmdoption-groonga-suggest-httpd-send-endpoint"></span><code class="sig-name descname">-s</code><code class="sig-prename descclassname"></code><code class="sig-prename descclassname">, </code><code class="sig-name descname">--send-endpoint</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-s" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>ユーザーの入力送信先になる <a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> のエンドポイントURIを指定します。</p>
<p>フォーマットは <code class="docutils literal notranslate"><span class="pre">tcp://${HOST}:${PORT}</span></code> です。たとえば、 <code class="docutils literal notranslate"><span class="pre">tcp://192.168.0.1:2929</span></code> のように指定します。</p>
<p>デフォルト値はありません。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-r">
<span id="cmdoption-groonga-suggest-httpd-receive-endpoint"></span><code class="sig-name descname">-r</code><code class="sig-prename descclassname"></code><code class="sig-prename descclassname">, </code><code class="sig-name descname">--receive-endpoint</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-r" title="この定義へのパーマリンク">¶</a></dt>
<dd><p><a class="reference internal" href="groonga-suggest-learner.html"><span class="doc">groonga-suggest-learner</span></a> が学習済みのサジェストデータを受信するために使用するURIを指定します。</p>
<p>フォーマットは <code class="docutils literal notranslate"><span class="pre">tcp://${HOST}:${PORT}</span></code> です。たとえば、 <code class="docutils literal notranslate"><span class="pre">tcp://192.168.0.1:2929</span></code> のように指定します。</p>
<p>デフォルト値はありません。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-l">
<span id="cmdoption-groonga-suggest-httpd-log-base-path"></span><code class="sig-name descname">-l</code><code class="sig-prename descclassname"></code><code class="sig-prename descclassname">, </code><code class="sig-name descname">--log-base-path</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-l" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>ログのパス名のプレフィックスを指定します。</p>
<p>デフォルト値はありません。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-n-lines-per-log-file">
<code class="sig-name descname">--n-lines-per-log-file</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-n-lines-per-log-file" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>1つのログファイルの最大行数を指定します。</p>
<p>デフォルトは <code class="docutils literal notranslate"><span class="pre">1000000</span></code> （100万行）です。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-d">
<span id="cmdoption-groonga-suggest-httpd-daemon"></span><code class="sig-name descname">-d</code><code class="sig-prename descclassname"></code><code class="sig-prename descclassname">, </code><code class="sig-name descname">--daemon</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-d" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>デーモン化する場合に指定します。</p>
<p>デフォルトではデーモン化しません。</p>
</dd></dl>

<dl class="std option">
<dt id="cmdoption-groonga-suggest-httpd-disable-max-fd-check">
<code class="sig-name descname">--disable-max-fd-check</code><code class="sig-prename descclassname"></code><a class="headerlink" href="#cmdoption-groonga-suggest-httpd-disable-max-fd-check" title="この定義へのパーマリンク">¶</a></dt>
<dd><p>起動時の最大ファイルディスクリプター数のチェックを無効化する場合に指定します。</p>
<p>デフォルトはチェックします。</p>
</dd></dl>

</div>
</div>
<div class="section" id="get-parameters">
<h2><span class="section-number">7.1.8.5. </span>GETの引数<a class="headerlink" href="#get-parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> GETパラメーターを受け付けます。</p>
<p>必須の引数があります。どれが必須かはクエリーの種類に依存します。</p>
<p>クエリーの種類が <code class="docutils literal notranslate"><span class="pre">complete</span></code> 、 <code class="docutils literal notranslate"><span class="pre">correct</span></code> 、 <code class="docutils literal notranslate"><span class="pre">suggest</span></code> のどれかのときは、道のパラメーターは <a class="reference internal" href="../commands/suggest.html"><span class="doc">suggest</span></a> にそのまま渡します。つまり、 <a class="reference internal" href="../commands/suggest.html"><span class="doc">suggest</span></a> のパラメーターを使うことができます。</p>
<div class="section" id="groonga-suggest-httpd-required-parameters">
<span id="id1"></span><h3><span class="section-number">7.1.8.5.1. </span>必須引数<a class="headerlink" href="#groonga-suggest-httpd-required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>次のパラメーターを指定する必要があります。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>キー</p></th>
<th class="head"><p>説明</p></th>
<th class="head"><p>備考</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">q</span></code></p></td>
<td><p>ユーザーの入力。UTF-8でエンコードされた文字列です。</p></td>
<td></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="required-parameters-for-learning">
<span id="groonga-suggest-httpd-required-parameters-learning"></span><h3><span class="section-number">7.1.8.5.2. </span>学習時に必須の引数<a class="headerlink" href="#required-parameters-for-learning" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><a class="reference internal" href="#cmdoption-groonga-suggest-httpd-s"><code class="xref std std-option docutils literal notranslate"><span class="pre">--send-endpoint</span></code></a> を指定したときは次のパラメーターを指定しなければいけません。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>キー</p></th>
<th class="head"><p>説明</p></th>
<th class="head"><p>備考</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">s</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">1970-01-01T00:00:00Z</span></code> から経過時間。</p></td>
<td><p>単位はミリ秒。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">i</span></code></p></td>
<td><p>各ユーザーを識別するユニークなID。</p></td>
<td><p>セッションID、IPアドレスなどを使うことができるでしょう。</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">l</span></code></p></td>
<td><p>1つ以上の学習対象のデータセット名。複数のデータセットを指定する場合は <code class="docutils literal notranslate"><span class="pre">dataset1|dataset2|dataset3</span></code> のように区切り文字として <code class="docutils literal notranslate"><span class="pre">|</span></code> を使います。</p></td>
<td><p>データセット名は <a class="reference internal" href="groonga-suggest-create-dataset.html"><span class="doc">groonga-suggest-create-dataset</span></a> で指定した名前です。</p></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="required-parameters-for-suggestion">
<span id="groonga-suggest-httpd-required-parameters-suggestion"></span><h3><span class="section-number">7.1.8.5.3. </span>サジェスト時に必須の引数<a class="headerlink" href="#required-parameters-for-suggestion" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">t</span></code> パラメータに <code class="docutils literal notranslate"><span class="pre">complete</span></code> 、 <code class="docutils literal notranslate"><span class="pre">correct</span></code> 、 <code class="docutils literal notranslate"><span class="pre">suggest</span></code> のどれかを指定したときは次のパラメーターを指定する必要があります。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>キー</p></th>
<th class="head"><p>説明</p></th>
<th class="head"><p>備考</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">n</span></code></p></td>
<td><p>サジェスト結果を計算するときに使うデータセット名。</p></td>
<td><p>データセット名は <a class="reference internal" href="groonga-suggest-create-dataset.html"><span class="doc">groonga-suggest-create-dataset</span></a> で指定した名前です。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">t</span></code></p></td>
<td><p>クエリーの種類。</p>
<p><code class="docutils literal notranslate"><span class="pre">complete</span></code> 、 <code class="docutils literal notranslate"><span class="pre">correct</span></code> 、 <code class="docutils literal notranslate"><span class="pre">suggest</span></code> のどれか。</p>
</td>
<td><p>複数の種類を指定することもできます。複数指定するときは <code class="docutils literal notranslate"><span class="pre">complete|correct</span></code> のように <code class="docutils literal notranslate"><span class="pre">|</span></code> で区切ってください。</p></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="groonga-suggest-httpd-optional-parameters">
<span id="id2"></span><h3><span class="section-number">7.1.8.5.4. </span>省略可能引数<a class="headerlink" href="#groonga-suggest-httpd-optional-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>いくつか省略可能な引数があります。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>キー</p></th>
<th class="head"><p>説明</p></th>
<th class="head"><p>備考</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">callback</span></code></p></td>
<td><p>JSONPの関数名</p></td>
<td></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="optional-parameters-for-learning">
<span id="groonga-suggest-httpd-optional-parameters-learning"></span><h3><span class="section-number">7.1.8.5.5. </span>学習時に指定可能な引数<a class="headerlink" href="#optional-parameters-for-learning" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><a class="reference internal" href="#cmdoption-groonga-suggest-httpd-s"><code class="xref std std-option docutils literal notranslate"><span class="pre">--send-endpoint</span></code></a> オプションを指定したときに指定可能なパラメーターは次の通りです。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>キー</p></th>
<th class="head"><p>説明</p></th>
<th class="head"><p>備考</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">t</span></code></p></td>
<td><p>クエリーの種類。</p>
<p>指定可能な値は <code class="docutils literal notranslate"><span class="pre">submit</span></code> だけです。</p>
</td>
<td><p>ユーザーが <code class="docutils literal notranslate"><span class="pre">q</span></code> で指定した入力をサブミットしたときは <code class="docutils literal notranslate"><span class="pre">submit</span></code> を指定してください。</p>
<p>まだサブミットされていないユーザーの入力を指定するときは <code class="docutils literal notranslate"><span class="pre">submit</span></code> を指定しないでください。 <code class="docutils literal notranslate"><span class="pre">submit</span></code> を指定していないときに <code class="docutils literal notranslate"><span class="pre">t</span></code> に <code class="docutils literal notranslate"><span class="pre">complete</span></code> 、 <code class="docutils literal notranslate"><span class="pre">correct</span></code> 、 <code class="docutils literal notranslate"><span class="pre">suggest</span></code> のうち1つ以上を指定するとサジェスト結果を使えます。これらの <code class="docutils literal notranslate"><span class="pre">t</span></code> に指定する値については <a class="reference internal" href="#groonga-suggest-httpd-required-parameters-suggestion"><span class="std std-ref">サジェスト時に必須の引数</span></a> を参照してください。</p>
</td>
</tr>
</tbody>
</table>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.1.8.6. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> のレスポンスは次のフォーマットになります。 <a class="reference internal" href="../commands/suggest.html"><span class="doc">suggest</span></a> のボディ部分と同じです。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>{
  TYPE1: [
    [CANDIDATE_1, SCORE_1],
    [CANDIDATE_2, SCORE_2],
    ...,
    [CANDIDATE_N, SCORE_N]
  ],
  TYPE2: [
    [CANDIDATE_1, SCORE_1],
    [CANDIDATE_2, SCORE_2],
    ...,
    [CANDIDATE_N, SCORE_N]
  ],
  ...
}
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">t</span></code> に <code class="docutils literal notranslate"><span class="pre">submit</span></code> を指定したときのレスポンスは次の通りです。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>{}
</pre></div>
</div>
<div class="section" id="type">
<h3><span class="section-number">7.1.8.6.1. </span><code class="docutils literal notranslate"><span class="pre">TYPE</span></code><a class="headerlink" href="#type" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p><code class="docutils literal notranslate"><span class="pre">complete</span></code> 、 <code class="docutils literal notranslate"><span class="pre">correct</span></code> 、 <code class="docutils literal notranslate"><span class="pre">suggest</span></code> のどれか。</p>
</div>
<div class="section" id="candidate-n">
<h3><span class="section-number">7.1.8.6.2. </span><code class="docutils literal notranslate"><span class="pre">CANDIDATE_N</span></code><a class="headerlink" href="#candidate-n" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>UTF-8でエンコードされた候補文字列。</p>
</div>
<div class="section" id="score-n">
<h3><span class="section-number">7.1.8.6.3. </span><code class="docutils literal notranslate"><span class="pre">SCORE_N</span></code><a class="headerlink" href="#score-n" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>候補のスコアー。</p>
<p>スコアーの降順でソートされた候補リスト。</p>
</div>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.1.8.7. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<blockquote>
<div><ul class="simple">
<li><p><a class="reference internal" href="../commands/suggest.html"><span class="doc">suggest</span></a></p></li>
</ul>
</div></blockquote>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.1.8. <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.1.8.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.1.8.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.1.8.3. 使い方</a><ul>
<li><a class="reference internal" href="#setup">7.1.8.3.1. セットアップ</a></li>
<li><a class="reference internal" href="#launch-groonga-suggest-learner">7.1.8.3.2. <code class="docutils literal notranslate"><span class="pre">groonga-suggest-learner</span></code> を起動</a></li>
<li><a class="reference internal" href="#launch-groonga-suggest-httpd">7.1.8.3.3. <code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code> を起動</a></li>
<li><a class="reference internal" href="#learn-from-user-inputs">7.1.8.3.4. ユーザーの入力から学習</a></li>
<li><a class="reference internal" href="#use-suggested-response">7.1.8.3.5. サジェスト結果を使う</a></li>
</ul>
</li>
<li><a class="reference internal" href="#command-line-parameters">7.1.8.4. コマンドライン引数</a><ul>
<li><a class="reference internal" href="#required-parameters">7.1.8.4.1. 必須引数</a><ul>
<li><a class="reference internal" href="#database-path">7.1.8.4.1.1. <code class="docutils literal notranslate"><span class="pre">DATABASE_PATH</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameters">7.1.8.4.2. 省略可能引数</a></li>
</ul>
</li>
<li><a class="reference internal" href="#get-parameters">7.1.8.5. GETの引数</a><ul>
<li><a class="reference internal" href="#groonga-suggest-httpd-required-parameters">7.1.8.5.1. 必須引数</a></li>
<li><a class="reference internal" href="#required-parameters-for-learning">7.1.8.5.2. 学習時に必須の引数</a></li>
<li><a class="reference internal" href="#required-parameters-for-suggestion">7.1.8.5.3. サジェスト時に必須の引数</a></li>
<li><a class="reference internal" href="#groonga-suggest-httpd-optional-parameters">7.1.8.5.4. 省略可能引数</a></li>
<li><a class="reference internal" href="#optional-parameters-for-learning">7.1.8.5.5. 学習時に指定可能な引数</a></li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.1.8.6. 戻り値</a><ul>
<li><a class="reference internal" href="#type">7.1.8.6.1. <code class="docutils literal notranslate"><span class="pre">TYPE</span></code></a></li>
<li><a class="reference internal" href="#candidate-n">7.1.8.6.2. <code class="docutils literal notranslate"><span class="pre">CANDIDATE_N</span></code></a></li>
<li><a class="reference internal" href="#score-n">7.1.8.6.3. <code class="docutils literal notranslate"><span class="pre">SCORE_N</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#see-also">7.1.8.7. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="groonga-suggest-create-dataset.html"
                        title="前の章へ"><span class="section-number">7.1.7. </span>groonga-suggest-create-dataset</a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="groonga-suggest-learner.html"
                        title="次の章へ"><span class="section-number">7.1.9. </span>groonga-suggest-learner</a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="groonga-suggest-learner.html" title="7.1.9. groonga-suggest-learner"
             >次へ</a> |</li>
        <li class="right" >
          <a href="groonga-suggest-create-dataset.html" title="7.1.7. groonga-suggest-create-dataset"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../executables.html" ><span class="section-number">7.1. </span>実行ファイル</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.1.8. </span><code class="docutils literal notranslate"><span class="pre">groonga-suggest-httpd</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>